﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTabControl;

namespace DynamicTabAppearance98573
{
    public partial class Form1 : Form
    {
        int activeTabIndex;
        int preActiveTabIndex;
        int PreviousTabIndex;
        
        //Set desired width of the activeTab
        int desiredActiveTabWidth = 250;

        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
            ultraTabControl1.ActiveTabChanged += new Infragistics.Win.UltraWinTabControl.ActiveTabChangedEventHandler(ultraTabControl1_ActiveTabChanged);
            ultraTabControl1.ActiveTabChanging += new ActiveTabChangingEventHandler(ultraTabControl1_ActiveTabChanging);
        }

        void ultraTabControl1_ActiveTabChanging(object sender, ActiveTabChangingEventArgs e)
        {
            //Monitor the tab's index which is being selected
            preActiveTabIndex = e.Tab.Index;

            //If the tab being selected has an index different from the active tab's, designate the tab that was previously active as the previous tab 
            if (preActiveTabIndex != activeTabIndex)
            {
                PreviousTabIndex = activeTabIndex;
            }
        }

        void ultraTabControl1_ActiveTabChanged(object sender, Infragistics.Win.UltraWinTabControl.ActiveTabChangedEventArgs e)
        {
            iterateTabs();

            //Apply an appearance to active tabs
            e.Tab.Appearance = activeAppearance;
            
            //Monitor the currently selected tabs index
            activeTabIndex = e.Tab.Index;

            //Apply an appearance to inactive tabs
            ultraTabControl1.Tabs[PreviousTabIndex].Appearance = inactiveAppearance;
        }

        Infragistics.Win.Appearance activeAppearance = new Infragistics.Win.Appearance("activeAppearance");
        Infragistics.Win.Appearance inactiveAppearance = new Infragistics.Win.Appearance("inactiveAppearance");

        void Form1_Load(object sender, EventArgs e)
        {
            //Apply some text to the tab captions
            ultraTabControl1.Tabs[0].Text = "Tab1";
            ultraTabControl1.Tabs[1].Text = "Tab2 has more text";
            ultraTabControl1.Tabs[2].Text = "Tab3 has even more text";

            iterateTabs();

            //Alter the appearance objects to differentiate them
            activeAppearance.ForeColor = Color.Red;
            inactiveAppearance.ForeColor = Color.Black;

            //Apply an appearance to the active tab during intialization
            ultraTabControl1.ActiveTab.Appearance = activeAppearance;
        }

        void iterateTabs()
        {
            foreach (UltraTab tab in ultraTabControl1.Tabs)
            {
                tab.FixedWidth = SetTabLength(tab.Index, tab.Active, tab.FixedWidth);
            }
        }

        //Resize all tabs so that they fully display their caption text
        public int SetTabLength(int tabIndex, bool activeTab, int tabWidth)
        {
            Graphics graphics = this.CreateGraphics();
            SizeF textSize = graphics.MeasureString(ultraTabControl1.Tabs[tabIndex].Text, this.Font);
            int tabTextLength = tabWidth;

            if (activeTab != true)
            {
                tabTextLength = (int)textSize.Width + 10;
            }
            else tabTextLength = desiredActiveTabWidth;

            return tabTextLength;
        }
    }
}
